#!/bin/sh
# $Id: t-bounce-12.sh,v 1.3 2014/01/11 17:15:34 ca Exp $
# Copyright (c) 2005 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ----------------------------------------
# test delay DSN and bounce DSN if timeouts are identical;
# including text of bounces delivered
# via lmtp to smtps3
# run smtp1.sh with different parameters
# ----------------------------------------
#

if test X"${MTA_NO_SLOW_TEST}" != "X"
then
  echo "SKIPPED: $0: MTA_NO_SLOW_TEST is set"
  exit 0
fi

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

chkcto qmgr MTA_DELAYED_DSN

if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

# cd to working directory for alias file!
cd ../qmgr || exit 1

# create aliases
${CAT} > ${ALI} <<EOF
abuse:	local:
postmaster:	local:
user:	local:
sender: local:
EOF
# create map
rm -f ${ALIMAP}
${MM} < ${ALI}
rm -f ${MTMAP}

# run some test programs

# ----------------------------------------
# temporary failure from SMTP sink; create a DSN
# check content
TEST=1
if echo "${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false
${CAT} > ${EDBROK} <<EOF
EOF
if ${SHELL} ${SD}/smtp1.sh -b -O ${EDBROK} -3 lmtpsock -Ssender@local.dom -R451@local.host -Q '-F 0x4000 -T R=11 -T w=10' -i 5 -s 20 -E 3 -X 0 -A 1
then
  if test -s ${B1}
  then
    preparedsn
    ${CAT} > ${OK} <<EOF
Return-Path: <>
From: Mailer-Daemon@
Subject: Undeliverable mail
To: <sender@local.dom>
MIME-Version: 1.0
Content-Type: multipart/report; report-type=delivery-status; boundary="${DELIM}"

This is a MIME-encapsulated message

--${DELIM}

${DSN_ERR}

Recipient:
<451@local.host>
Remote-MTA: 127.0.0.1
Reason:
451 whatever
during RCPT
maximum time in queue exceeded

--${DELIM}
Content-Type: message/delivery-status

Reporting-MTA: dns; ${HOSTNAME}

Final-Recipient: rfc822;<451@local.host>
Action: failed
Remote-MTA: dns; 127.0.0.1
Status: 4.0.0
Diagnostic-Code: smtp; 451 whatever

--${DELIM}
Content-Type: message/rfc822

EOF
    chkdsn

    ls ?/S0* > ${TMP} 2>/dev/null
    if test -s ${TMP}
    then
      ${VERBOSE} && echo "$0: CDB entry still exists"
      ERR=true
    fi

    if test -s ${B2}
    then
      ERR=true
    fi
  else
     ERR=true
  fi
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi
fi


# ----------------------------------------
# end
if test ${ERRS} -eq 0
then
  rm -f ${EDBROK} ${OK} ${OUT} ${TMP}
  exit 0
else
  echo "$0: ${ERRS} error(s)"
  exit 1
fi
