#!/bin/sh
# $Id: t-conf-7.sh,v 1.1 2011/03/11 18:32:30 ca Exp $
# Copyright (c) 2011 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# --------------------------------------------
# test argv handling
# --------------------------------------------

test -s stop && exit 1

# source directory of this (and other) shell script
SD=`dirname $0`

ERRS=0
CNF=sm7.conf
OUT=sm7.out
OK=sm7.ok
PRG=./t-conf-7

# --------------------------------------------
cat > ${CNF} <<EOF
nameservers = { 10.51.5.10, 10.51.105.10, 10.51.5.13, 10.51.105.13 }
EOF
cat > ${OK} <<EOF
# List of nameservers (IPv4 addresses)
nameservers={10.51.5.10, 10.51.105.10, 10.51.5.13, 10.51.105.13, }
EOF
if ${PRG} ${CNF} >${OUT} 2>&1
then
  if diff ${OK} ${OUT}
  then
    :
  else
    ERRS=`expr ${ERRS} + 1 `
    test X"${MTA_STOPONERROR}" != X && exit 1
  fi
else
  ERRS=`expr ${ERRS} + 1 `
  test X"${MTA_STOPONERROR}" != X && exit 1
fi

# --------------------------------------------
cat > ${CNF} <<EOF
nameservers = { 10.51.5.10, 10.51.105.10, }
EOF
cat > ${OK} <<EOF
# List of nameservers (IPv4 addresses)
nameservers={10.51.5.10, 10.51.105.10, }
EOF
if ${PRG} ${CNF} >${OUT} 2>&1
then
  if diff ${OK} ${OUT}
  then
    :
  else
    ERRS=`expr ${ERRS} + 1 `
    test X"${MTA_STOPONERROR}" != X && exit 1
  fi
else
  ERRS=`expr ${ERRS} + 1 `
  test X"${MTA_STOPONERROR}" != X && exit 1
fi

# --------------------------------------------
cat > ${CNF} <<EOF
nameservers = { 10.51.5.10, 10.51.105.10, 1.2.3.4, 5.6.7.8, 9.10.11.12 }
EOF
cat > ${OK} <<EOF
(while scanning) ${CNF}: invalid value
${CNF}:1: nameservers: overflow -- too many elements in list
EOF
if ${PRG} ${CNF} >${OUT} 2>&1
then
  ERRS=`expr ${ERRS} + 1 `
  test X"${MTA_STOPONERROR}" != X && exit 1
else
  if diff ${OK} ${OUT}
  then
    :
  else
    ERRS=`expr ${ERRS} + 1 `
    test X"${MTA_STOPONERROR}" != X && exit 1
  fi
fi


# ----------------
test ${ERRS} -eq 0 && exit 0

echo "$0: ${ERRS} error(s)"
exit 1
