#!/bin/sh
# $Id: t-rcptcnf-1.sh,v 1.5 2014/05/30 19:20:21 ca Exp $
#
# ------------------------------------------------------------
# Description:
# Script to test smtpc_rcpt_conf
# ------------------------------------------------------------

TPRG=./t-smar-1
SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../smar
fi
. ${SD}/common.sh

if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

rm -f ${ACCMAP} ${SOCK} ${PIDS} ${MT}

# create access map for tests
${VALGRIND} ${MM} -t'	' -F ${ACCMAP} <<EOF
smtpc_rcpt_conf:@example.com	tls_requirements { flags={verified}; cipher_bits_min=256; hostnames = { .example.com, .example.org }; cert_fps = { 36:3F:3C:D5:5C:86:5B:FA:6B:25:4D:E9:E5:AA:AF:50:4E:D2:CD:BD, 60:5C:AB:A5:1B:08:43:23:E9:DC:21:AD:CB:AC:29:76:FA:2D:F4:54, D1:2C:D9:2C:EC:34:D7:09:57:54:19:F4:4F:FF:69:4C:D5:AC:5A:83, C2:8C:C4:43:58:6B:CE:78:67:C5:26:88:54:23:47:F1:5B:CB:F7:51, }}
EOF

trap killit 2

# start SMAR
${SHELL} ${SD}/startsmar.sh -d 9 ${SMAROPTS} || exit 1
rm -f ${OUT} ${IP} ${OK}

TEST=1
# ----------------------------------------
if echo "${SKIP} X" | grep -v ' '${TEST}' ' > /dev/null
then
${VALGRIND} ${TPRG} -c '<rcpt@example.com>' > ${OUT} 2>&1
grep '^react=' ${OUT} > ${IP}
cat > ${OK} <<EOF
react=smtpc_rcpt_conf, ret=0, resconf=0
react=smtpc_rcpt_conf, ret=0, rhsconf='tls_requirements { flags={verified}; cipher_bits_min=256; hostnames = { .example.com, .example.org }; cert_fps = { 36:3F:3C:D5:5C:86:5B:FA:6B:25:4D:E9:E5:AA:AF:50:4E:D2:CD:BD, 60:5C:AB:A5:1B:08:43:23:E9:DC:21:AD:CB:AC:29:76:FA:2D:F4:54, D1:2C:D9:2C:EC:34:D7:09:57:54:19:F4:4F:FF:69:4C:D5:AC:5A:83, C2:8C:C4:43:58:6B:CE:78:67:C5:26:88:54:23:47:F1:5B:CB:F7:51, }}'
EOF
if diff ${OK} ${IP}
then
  :
else
  ERRS=`expr ${ERRS} + 1 `
  echo "$0: test ${TEST} failed."
  test X"${MTA_STOPONERROR}" != X && exit ${ERRS}
fi
fi


# ----------------
# stop SMAR
for i in `cat ${PIDS}`
do
  kill ${i}
done
# ----------------
# thanks kids for not following the POSIX standard...
if test X"`uname`" = "XLinux"
then
  killall smar
fi
sleep 3

[ ${ERRS} -eq 0 ] && rm -f ${OUT} ${IP} ${OK}
exit ${ERRS}
